unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst,pngimage,jpeg, Menus, ExtCtrls,
  Shellapi, dxGDIPlusClasses;

type
  TForm1 = class(TForm)
    CheckListBox1: TCheckListBox;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button2: TButton;
    Label3: TLabel;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Image1: TImage;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
implementation
  uses FileCtrl,ShlObj, ActiveX;
{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  cmd : string;
  i : Integer;
  pr,dir:string;

begin
  //    ,    Run/parameters
  //      : -parm1 -parm2

  //    -  ,  0-  
  //    Windows
  //      FileList
  dir:=ParamStr(2);
  for i := 3 to ParamCount do begin
     pr:=ParamStr(i);
     if pr<>'' then  if pr[1]='*' then begin pr:=dir+copy(pr,2,length(pr)); end;
     form1.CheckListBox1.Checked[form1.CheckListBox1.Items.Add(pr)]:=true;
  end;


  //  FileList



end;
 function SelectDirCB(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  if (uMsg = BFFM_INITIALIZED) and (lpData <> 0) then
    SendMessage(Wnd, BFFM_SETSELECTION, Integer(True), lpdata);
  result := 0;
end;
 
function SelectDirectory(wnd:HWND; const Caption: string; SelRoot: string=''; const Root: WideString='';
                         cFlags:cardinal=BIF_RETURNONLYFSDIRS): string;
var
  WindowList: Pointer;
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  OldErrorMode: Cardinal;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten, Flags: LongWord;
begin
  Result := '';
  if not DirectoryExists(SelRoot) then SelRoot := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      RootItemIDList := nil;
      if Root <> '' then
      begin
        SHGetDesktopFolder(IDesktopFolder);
        IDesktopFolder.ParseDisplayName(Application.Handle, nil,
          POleStr(Root), Eaten, RootItemIDList, Flags);
      end;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);
        ulFlags :=cFlags;
        if SelRoot <> '' then
        begin
          lpfn := SelectDirCB;
          lParam := Integer(PChar(SelRoot));
        end;
      end;
      WindowList := DisableTaskWindows(0);
      OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        SetErrorMode(OldErrorMode);
        EnableTaskWindows(WindowList);
      end;
      if ItemIDList <> nil then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        SetString(Result,Buffer,lstrlen(Buffer));
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
close;
end;

Procedure ConvertFilePNG(Fln1,fln2:string);
var PngImage:TPNGObject;
    BMP:TBitMap;
begin
try
 PngImage:=TPNGObject.create;
 PngImage.LoadFromFile(Fln1);
 BMP:=TBitMap.Create;
 BMP.Width:=PngImage.Width;
 BMP.Height:=PngImage.Height;
 BMP.Canvas.Draw(0,0,PngImage);
 BMP.SaveToFile(fln2);
 BMP.Free;
 PngImage.Free;
 except
 end;
end;
procedure JPEGtoBMP(const FileName: TFileName);
var
  jpeg: TJPEGImage;
  bmp:  TBitmap;
begin
  jpeg := TJPEGImage.Create;
  try
    jpeg.CompressionQuality := 100; {Default Value}
    jpeg.LoadFromFile(FileName);
    bmp := TBitmap.Create;
    try
      bmp.Assign(jpeg);
      bmp.SaveTofile(ChangeFileExt(FileName, '.bmp'));
    finally
      bmp.Free
    end;
  finally
    jpeg.Free
  end;
end;
procedure BMPToJPEG(const FileName: TFileName);
var
  jpeg: TJPEGImage;
  bmp:  TBitmap;
begin
  bmp := Tbitmap.Create;
  jpeg := TJPEGImage.Create;
  try
    bmp.LoadFromFile(FileName);
    try
      jpeg.Assign(bmp);
      jpeg.CompressionQuality := 100; {Default Value}
      jpeg.SaveTofile(ChangeFileExt(FileName, '.jpg'));
    finally
      bmp.Free;
      jpeg.Free;
    end;
  finally

  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var x:integer;
begin
  for X:=0 to form1.CheckListBox1.Items.Count-1 do begin
  try
  if form1.CheckListBox1.Checked[x] then
  if form1.ComboBox1.ItemIndex=1 then
    JPEGtoBMP(form1.CheckListBox1.Items[x])
    else BMPToJPEG(form1.CheckListBox1.Items[x])

    except
    end;
  end;
  Showmessage(' ! ');
end;

procedure TForm1.N1Click(Sender: TObject);
var x:integer;
begin
  for X:=0 to form1.CheckListBox1.Items.Count-1 do
  form1.CheckListBox1.Checked[x]:=true;

end;

procedure TForm1.N2Click(Sender: TObject);
var x:integer;
begin
  for X:=0 to form1.CheckListBox1.Items.Count-1 do
  form1.CheckListBox1.Checked[x]:=False;

end;



procedure TForm1.N3Click(Sender: TObject);
var x:integer;
begin
  for X:=0 to form1.CheckListBox1.Items.Count-1 do
  if form1.CheckListBox1.Checked[x] then form1.CheckListBox1.Checked[x]:=false
  else form1.CheckListBox1.Checked[x]:=true;

end;

procedure TForm1.Label4Click(Sender: TObject);
begin
Shellapi.ShellExecute(application.Handle,'open',pchar(label1.caption),'','',5);

end;

procedure TForm1.Label5Click(Sender: TObject);
var dir:string;
begin
getdir(0,dir);
  Shellapi.ShellExecute(application.Handle,'open',pchar('regsvr32'),pchar('"'+dir+'\contmenu_fordll.dll"'),'',5);
end;

end.
